package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;
import io.github.jhipster.service.filter.InstantFilter;

/**
 * Criteria class for the TBSuppliesPriceHistory entity. This class is used in TBSuppliesPriceHistoryResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-supplies-price-histories?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBSuppliesPriceHistoryCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private InstantFilter priceForm;

    private DoubleFilter price;

    private LongFilter tbSuppliesOrderId;

    private LongFilter tbSuppliesInWarehouseId;

    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public InstantFilter getPriceForm() {
        return priceForm;
    }

    public void setPriceForm(InstantFilter priceForm) {
        this.priceForm = priceForm;
    }

    public DoubleFilter getPrice() {
        return price;
    }

    public void setPrice(DoubleFilter price) {
        this.price = price;
    }

    public LongFilter getTbSuppliesOrderId() {
        return tbSuppliesOrderId;
    }

    public void setTbSuppliesOrderId(LongFilter tbSuppliesOrderId) {
        this.tbSuppliesOrderId = tbSuppliesOrderId;
    }

    public LongFilter getTbSuppliesInWarehouseId() {
        return tbSuppliesInWarehouseId;
    }

    public void setTbSuppliesInWarehouseId(LongFilter tbSuppliesInWarehouseId) {
        this.tbSuppliesInWarehouseId = tbSuppliesInWarehouseId;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBSuppliesPriceHistoryCriteria that = (TBSuppliesPriceHistoryCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(priceForm, that.priceForm) &&
            Objects.equals(price, that.price) &&
            Objects.equals(tbSuppliesOrderId, that.tbSuppliesOrderId) &&
            Objects.equals(tbSuppliesInWarehouseId, that.tbSuppliesInWarehouseId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        priceForm,
        price,
        tbSuppliesOrderId,
        tbSuppliesInWarehouseId
        );
    }

    @Override
    public String toString() {
        return "TBSuppliesPriceHistoryCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (priceForm != null ? "priceForm=" + priceForm + ", " : "") +
                (price != null ? "price=" + price + ", " : "") +
                (tbSuppliesOrderId != null ? "tbSuppliesOrderId=" + tbSuppliesOrderId + ", " : "") +
                (tbSuppliesInWarehouseId != null ? "tbSuppliesInWarehouseId=" + tbSuppliesInWarehouseId + ", " : "") +
            "}";
    }

}
